class LevelObjsClass{
	constructor(parent){
		this.parent=parent;
		this.WorldRect=class extends Sprite{
			constructor(coords=[0,0],size=[0,0],rotation=0,col="darkGrey",type="normal"){
				super(parent,(sprite)=>{
					sprite.type=type;
					sprite.hasDraw=5;
					sprite.pos.coords=coords;
					sprite.pos.size=size;//diamiter
					sprite.pos.rotation=rotation;
					sprite.col=col;
					sprite.basicDraw=function(){
						ctx.fillStyle=this.col;
						ctx.fillRect(-this.pos.size[0]/2,-this.pos.size[1]/2,this.pos.size[0],this.pos.size[1])
					}
					sprite.drawShaded=function(){
						ctx.fillStyle=this.col;
						ctx.fillRect(-this.pos.size[0]/2,-this.pos.size[1]/2,this.pos.size[0],this.pos.size[1])
						ctx.fillStyle="#00000055";
						ctx.fillRect(-this.pos.size[0]/2,-this.pos.size[1]/2,this.pos.size[0],this.pos.size[1])
						//ctx.stroke();
					}
					sprite.DrawSprite=function(){
						let a=Math.dif2(this.pos.coords,player1.coords);
						if(Math.abs(a[0])+Math.abs(a[1])>this.pos.size[0]+this.pos.size[1]+(Draw.width+Draw.height)){
							return;
						}
						ctx.translate(this.pos.coords[0],this.pos.coords[1]);
						let c=[2,2];
						//ctx.translate(c[0],c[1])
						//ctx.rotate(this.pos.rotation);
						//this.drawShaded();
						//ctx.rotate(-this.pos.rotation);
						//ctx.translate(-c[0],-c[1])
						ctx.rotate(this.pos.rotation);
						this.basicDraw();
						ctx.rotate(-this.pos.rotation);
						ctx.translate(-this.pos.coords[0],-this.pos.coords[1]);
					}
				},true,false);
			}
		}
		this.Textbox=class extends Sprite{
			constructor(coords=[0,0],size=[800,500],rotation=0,text=[],colour="white",fontSize=10){
				super(parent,(sprite)=>{
					sprite.hasDraw=5;
					sprite.pos.coords=coords;
					sprite.pos.rotation=rotation;
					sprite.colour=colour;
					sprite.pos.coords=coords;
					sprite.pos.coords=coords;
					sprite.text=Clone(text);
					sprite.fontSize=fontSize;
					sprite.DrawSprite=function(){
						let a=Math.dif2(this.pos.coords,player1.coords);
						if(Math.abs(a[0])+Math.abs(a[1])>(this.pos.size[0]+this.pos.size[1])+(Draw.width+Draw.height)){
							return;
						}
						ctx.fillStyle=this.colour;
						ctx.font = this.fontSize+"px arial";
						ctx.translate(this.pos.coords[0],this.pos.coords[1]);
						ctx.rotate(this.pos.rotation);
						for (var i = 0; i < this.text.length; i++) {
							ctx.fillText(this.text[i],0,i*this.fontSize);
						}
						ctx.rotate(-this.pos.rotation);
						ctx.translate(-this.pos.coords[0],-this.pos.coords[1]);
					};
				},true,false);
			}
		}
		this.Checkpoint=class extends Sprite{
			constructor(pos,code){
				super(parent,(sprite)=>{
					sprite.pos=pos;
					sprite.hasDraw=4;
					sprite.hasUpdate=3;
					sprite.boxObj=parent.MakeGame.packages[0];
					sprite.boxCoords=Clone(pos.coords);
					sprite.playerCoords=Clone(pos.coords);
					sprite.playerCoords[1]-=20;
					sprite.chargeSpeed=1/2;
					let wall=parent.MakeGame.WorldRect;
					parent.MakeGame.worldRects.push(
						new wall(Math.addVec2([0,+pos.size[1]/2-10],pos.coords),[pos.size[0],20],0,"blue","carpet"),
					);
					sprite.Start=function(){
						this.active=false;
						this.detectedObj=false;
						this.detectedTime=0;
						this.power=0;
						this.powered=false;
						this.drawEvent="none";
					}
					sprite.Update=function(){
						let find=(this.inHitbox(this.boxObj))<=0;
						if(find!=this.detectedObj){
							
							if(this.detectedObj&&!this.active){
								this.drawEvent="charging";
							}else{
								this.drawEvent="none";
							}
							this.detectedObj=find;
						}
						if(this.active){
							if(this.boxObj.checkpointObj!=this){
								this.power=0;
								this.powered=false;
								this.active=false;
							}
							this.detectedTime=this.detectedTime+this.time.delta;
						}
						else{
							let power=Math.clamp(-100,120,this.detectedObj?this.boxObj.health*1.5:0);
							let spd=this.chargeSpeed*this.time.delta;
							//this.power+=Math.clamp(-spd,spd,power);
							this.power=Math.clamp(0,100,Math.lerpT(this.power,power,0.9,this.time.delta));
							if(this.detectedObj){
								if(this.detectedTime<1){
								}
								if(this.power>=100){
									this.detectedTime=0;
									this.drawEvent="nowActive";
									this.powered=true;
									this.active=true;
									this.boxObj.checkpointObj=this;
									this.setCheckpoint();
								}
							}
							else{
							}
						}
					}
					sprite.setCheckpoint=function(){
						this.active=true;
						this.boxObj.checkpointObj=this;
						this.boxObj.spawnCoords=this.boxCoords;
						this.parent.MakeGame.player1.spawnCoords=this.playerCoords;
					}
					sprite.inHitbox=function(obj){
						let dif=Math.dif2(obj.coords,this.pos.coords);
						let dif2=[
							Math.max(0,Math.abs(dif[0])-this.pos.size[0]/2),
							Math.max(0,Math.abs(dif[1])-this.pos.size[1]/2),
						]
						let dist=Math.len2(dif2);
						return dist-obj.size;
					}
					sprite.s=function(obj){
					}
					sprite.baceDraw=function(){
						ctx.fillStyle=Draw.hslColour(0.16,0.7,0.6+0.3*Math.sin(this.time.start));
						ctx.fillRect(-this.pos.size[0]/2,-this.pos.size[1]/2,this.pos.size[0],this.pos.size[1]);
						{
							let c=[-16,-this.pos.size[0]/2-10];
							ctx.translate(c[0],c[1]);
							ctx.fillStyle="#BBBBBB";
							ctx.fillRect(0,0,60,16);
							ctx.fillStyle="black";
							ctx.font="14px arial";
							let p=Math.clamp(0,100,this.power);
							if(!this.detectedObj){
								//ctx.fillText("power:"+p,0,13)
							}
							if(!this.active){
								ctx.fillText("power:"+p+"%",0,13)
							}
							else{
								ctx.fillText(":)"+p,0,13)
							}
							ctx.translate(-c[0],-c[1]);
						}
						if(this.active){
							let t=Math.clamp(0,1,this.detectedTime/0.5);
							let c=[0,-20+this.pos.size[0]/2];
							ctx.translate(c[0],c[1]);
							let goal=[4,100,40,30,1];//Diamiters: Flagpoll:x,y, Flag:x,y, borderWidth
							{
								let t1=Math.clamp(0,1,t*2);
								ctx.fillStyle="black";
								ctx.fillRect(-goal[0]/2-goal[4]/2,0,goal[4]+goal[0],-t1*goal[1]);
								ctx.fillStyle="#BBBBBB";
								ctx.fillRect(-goal[0]/2,0,goal[0],-t1*goal[1]);
							}
							{
								let t2=Math.clamp(0,1,t*2-1);
								ctx.fillStyle="black";
								ctx.fillRect(goal[0]/2,-goal[1]-goal[4]/2,t2*goal[2]+goal[4],goal[3]);
								ctx.fillStyle="#00FF00";
								ctx.fillRect(goal[0]/2,-goal[1],t2*goal[2],goal[3]);
							}
							ctx.fillStyle="black";
							ctx.font="14px arial";
							let p=Math.clamp(0,100,this.power);
							if(!this.active){
								ctx.fillText("HP:"+p,0,13)
							}
							ctx.translate(-c[0],-c[1]);
						}
					}
					sprite.DrawSprite=function(){
						ctx.translate(this.pos.coords[0],this.pos.coords[1]);
						ctx.rotate(this.pos.rotation);
						this.baceDraw();
						ctx.rotate(-this.pos.rotation);
						ctx.translate(-this.pos.coords[0],-this.pos.coords[1]);
					}
				},true,false);
				code(this);
			}
		}
	}
}
{
		/*let rects=[
			["w",[400,200],[20,100],0,"grey","normal"],
			["w",[400,200],[20,100],0,"grey","normal"],
			["w",[100,200],[20,100],0,"grey","normal"],
			["w",[100,200],[20,100],0,"grey","normal"],
			["w",[174,290],[180,20],0.55,"grey","normal"],

			["w",[400,350],[300,20],0.07,"grey","normal"],//starting box
			["w",[600,370],[140,10],0,"grey","normal"],
			["w",[738,379],[150,20],0,"blue","carpet"],

			["w",[190,50],[20,300],0.8,"grey","normal"],

			["w",[300,0],[100,20],0,"grey","normal"],
			["w",[260,240],[100,20],0.1,"grey","normal"],

			//[[0,700],[100000,40],0.2,"grey","normal"],
			["w",[700,300],[100,20],0,"blue","carpet"],
			["w",[700,140],[40,40],0.1,"grey","normal"],
		];
		let l=10;
		for (var i = 0; i < l; i++) {
			rects.push(["w",[900+i*100,140+Math.pow(4.2,i-4.32)%50],[40,40],0.1,"grey","normal"]);
			rects.push(["w",[900+i*100+134,280+Math.pow(4.2,i)%50],[40,40],0.1,"grey","normal"]);
		}
		let c=[900+100*l,260];
		rects.push(["w",c,[123,20],0.1,"blue","carpet"]);
		rects.push(["w",Math.addVec2(c,[50,-10]),[20,28],0.2,"blue","carpet"]);
		rects.push(["w",Math.addVec2(c,[-50,-10]),[20,28],-0.2,"blue","carpet"]);
		rects.push(["w",Math.addVec2(c,[-200,-200]),[160,20],-0.2,"blue","normal"]);
		rects.push(["w",Math.addVec2(c,[200,-100]),[20,160],-0.4,"blue","carpet"]);
		c=Math.addVec2(c,[-100,20]);
		let packages=[
			[[480,280],12,"red",8],
		];
		//for (let i of rects) {
			//this.worldRects.push(new this.WorldRect(i[0],i[1],i[2],i[3],i[4]));
		//}
		for (let i of packages) {
			this.packages.push(new this.Package(i[0],i[1],i[2],i[3]));
		}
		//for (let i of rects) {
			//this.worldRects.push(new this.WorldRect(i[0],i[1],i[2],i[3],i[4]));
		//}
		new this.Checkpoint(new Position(
			new Position({coords:[610,350],rotation:0,size:[80,60]}),
		),(sprite)=>{sprite.Start()},);
		new this.Checkpoint(new Position(
			new Position({coords:[3400,240],rotation:0,size:[80,60]}),
		),(sprite)=>{sprite.Start()},);*/
		//this.loadPart([["c",[1900,237]],["c",[610,350]]]);
}